
SETUP_INFO = dict(
    name = 'infinishell',
    version = '2.2.8.20',
    author = 'Mark Vasilkov',
    author_email = 'mvasilkov@gmail.com',

    url = 'http://www.infinidat.com',
    license = 'PSF',
    description = """Infinidat Management Shell""",
    long_description = """Infinidat Management Shell""",

    # http://pypi.python.org/pypi?%3Aaction=list_classifiers
    classifiers = [
        "Intended Audience :: Developers",
        "Intended Audience :: System Administrators",
        "License :: OSI Approved :: Python Software Foundation License",
        "Operating System :: OS Independent",
        "Programming Language :: Python",
        "Topic :: Software Development :: Libraries :: Python Modules",
    ],

    install_requires = [
'capacity>=1.3.8',
'colorama>=0.3.7',
'infi.shell==2.0.12',
'ipaddress>=1.0.16',
'munch>=2.0.4',
'requests-toolbelt>=0.6.0',
'requests>=2.9.1',
'setuptools>=19.2.0.1'
],
    namespace_packages = ['infinishell'],

    package_dir = {'': 'src'},
    package_data = {'': []},
    include_package_data = True,
    zip_safe = False,

    entry_points = dict(
        console_scripts = ['infinishell = infinishell.entry_points:main'],
        gui_scripts = []),
    )

platform_install_requires = {
    'windows' : ['pyreadline>=2.0'],
    'linux' : [],
    'macosx' : ['readline==6.2.2'],
}

def _get_os_name():
    import platform
    system = platform.system().lower().replace('-', '').replace('_', '')
    if system == 'darwin':
        return 'macosx'
    return system


def setup():
    from setuptools import setup as _setup
    from setuptools import find_packages
    SETUP_INFO['packages'] = find_packages('src')
    SETUP_INFO['install_requires'] += platform_install_requires.get(_get_os_name(), [])
    _setup(**SETUP_INFO)

if __name__ == '__main__':
    setup()

