class User(object):
    def __init__(self, username, roles):
        self.username = username
        self.roles = Roles(roles)
    def has_role(self, *roles):
        return self.roles.has_role(*roles)

class Roles(object):
    INFINIDAT = 'INFINIDAT'
    ADMIN = 'ADMIN'
    POOLADMIN = 'POOL_ADMIN'
    TECHNICIAN = 'TECHNICIAN'
    READONLY = 'READ_ONLY'

    all = tuple(value for key, value in locals().iteritems() if key[0] != '_' and key.isupper())

    CUSTOMER_ROLES = set((ADMIN, POOLADMIN, READONLY))

    def __init__(self, roles):
        self.roles = tuple(role.upper() for role in roles)
    def has_role(self, *roles):
        return any(role.upper() in self.roles for role in roles)
    def is_infinidat(self):
        return self.has_role(self.INFINIDAT)
    def is_technician(self):
        return self.has_role(self.TECHNICIAN)
    def is_admin(self):
        return self.has_role(self.ADMIN)
    def is_customer(self):
        # Everything is already in uppercase
        return any(role in self.CUSTOMER_ROLES for role in self.roles)
    @classmethod
    def is_customer_role(cls, role):
        return role.upper() in cls.CUSTOMER_ROLES
    def __repr__(self):
        return 'Roles({})'.format(", ".join('"{}"'.format(self.roles)))
    def __str__(self):
        return '<Roles: {}>'.format(", ".join(self.roles))
